<!DOCTYPE html>
<html lang="en">

<head>
   <meta charset="UTF-8">
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   <meta http-equiv="X-UA-Compatible" content="ie=edge">
   <title>Document</title>
   <style>
      @charset "utf-8";

      body {
         padding: 16px;
      }

      button[is="mi-boton-extendido"] {
         padding: 10px;
         font-weight: bold;
      }
   </style>
</head>

<body>

   <p>Custom element extendido</p>
   <button is="mi-boton-extendido">soy un mi-boton</button>
   <div id="container"></div>
   
   <script>
      class MiBotonExtendido extends HTMLButtonElement {
         constructor() {
            super();
            this.addEventListener('click', (e) => {
               console.log("evento click: " + this.innerHTML);
               alert('Mi Boton Extendido');
            });
         }
         static get ceName() {
            return 'mi-boton-extendido';
         }
         get is() {
            return this.getAttribute('is');
         }
         set is(value) {
            this.setAttribute('is', value || this.ceName);
         }
      }

      customElements.define('mi-boton-extendido', MiBotonExtendido, { extends: 'button' });
      //customElements.define(MiBotonExtendido.ceName, MiBotonExtendido, { extends: 'button' });

      const miBotonExtendido2 = document.createElement('button', { is: MiBotonExtendido.ceName });

      miBotonExtendido2.textContent = "Soy un mi-boton-extendido";
      document.body.appendChild(miBotonExtendido2);

      const miBotonExtendido3 = document.createElement('button', { is: MiBotonExtendido.ceName });

      miBotonExtendido3.textContent = "Hola-btn3";
      document.querySelector("#container").appendChild(miBotonExtendido3);

   </script>

</body>

</html>